module Pondize
  class Runner
    def start
      if ARGV.length != 2
        puts '2 arguments are needed tonality (-7..7) and string'
        return 1
      end

      key_signature= ARGV.first.to_i

      puts Convert.new(key_signature, ARGV.last).pondize
      0
    end
  end

  class Convert

    CIRCLE = "fcgdaeb"

    ACCIDENTALS = ['l', 'n', 's']

    OCTAVES = [",", "'"]

    def initialize key_signature, chars
      @key_signature = key_signature
      @chars = chars
    end

    def pondize chars = nil
      @chars = chars || @chars
      @chars.each_char
        .map
        .with_index { |char, index| (notes_to_change.include?(char) && !ACCIDENTALS.include?(@chars[index + 1]) ) ? "#{char}#{change_to}" : char }
        .map.with_index { |char, index| (ACCIDENTALS + OCTAVES).include?(@chars[index + 1]) ? char : "#{char} " }
        .join('')
        .gsub('n', '')
        .gsub(/ (\d)/, '\1')
        .gsub(/ -(\d)/, '-\1')
        .gsub('< <', '<<')
        .gsub('> >', '>>')
        .gsub(' .', '.')
        .gsub('l', 'f')
        .strip
    end

    def change_to
      if @key_signature > 0
        return 's'
      end
      if @key_signature < 0
        return 'f'
      end
      ''
    end

    def notes_to_change
      if @key_signature > 0
        return CIRCLE[0...@key_signature]
      end
      if @key_signature < 0
        return CIRCLE[@key_signature..-1]
      end
      []
    end
  end

end
